<script setup lang="ts">
import { Player, Position, SgfParserService, SgfWriterService, useGoValidator } from '@go158/go-validator';

const { id } = useRoute().query;
const player = ref<Player>();
const loading = ref<boolean>(true);
const copied = ref<boolean>(false);

if (id === undefined) throw createError({ statusCode: 400, message: 'Game id not provided' });

const gameRecord = useLocalStorage<string>(id as string, '');

const { initial, current, addMove, setInitialBoardState, navigator: gameNavigator } = useGoValidator();

if (gameRecord.value.length > 0) {
  const initialBoardState = SgfParserService.parseSgf(gameRecord.value);
  setInitialBoardState(initialBoardState);
  gameNavigator.navigateToLeaf();
}

const supabase = useSupabaseClient();

const channel = supabase.channel('test', { config: { broadcast: { self: true } } });
if (process.client) {
  channel
    .on('broadcast', { event: `${id}` }, ({ payload: { position, player } }) => {
      addMove({ player, position });
      gameRecord.value = SgfWriterService.fromBoardState(initial.value.boardState);
    })
    .subscribe(async (status) => {
      if (status === 'SUBSCRIBED') {
        try {
          const { player: assignedPlayer } = await $fetch('/api/join', { method: 'POST', body: { id } });
          player.value = assignedPlayer;
        } catch {}

        loading.value = false;
      }
    });
}

const handlePositionClicked = (position: Position) => {
  if (player.value === undefined) return;
  channel.send({ type: 'broadcast', event: `${id}`, payload: { position, player: player.value } });
};

const copyToClipboard = () => {
  copied.value = true;
  setTimeout(() => {
    copied.value = false;
  }, 1000);
  navigator.clipboard.writeText(id as string);
};
</script>

<template>
  <div class="mx-auto flex h-screen max-w-3xl items-center justify-center p-2">
    <div v-if="loading">
      <Icon name="prime:spinner" class="animate-spin" />
    </div>

    <div v-else-if="player === undefined" class="flex flex-col items-center gap-4">
      <span>Game is full or has ended</span>
      <NuxtLink to="/" class="rounded-lg border border-neutral-800 px-3 py-1">Go back</NuxtLink>
    </div>

    <div v-else class="flex w-full flex-col gap-4">
      <span class="text-2xl font-bold">{{ player === Player.BLACK ? 'You are black' : 'You are white' }}</span>

      <div class="flex w-full items-center justify-between gap-2">
        <div class="flex flex-col">
          <span>Game Id</span>
          <span class="text-xs text-neutral-600">share this with someone</span>
        </div>

        <button
          class="flex flex-row gap-4 rounded-md bg-neutral-200 px-4 py-2 duration-150 hover:bg-neutral-300"
          @click="copyToClipboard"
        >
          <span class="font-mono">{{ id }}</span>
          <Icon size="20" :name="copied ? 'solar:clipboard-check-outline' : 'solar:clipboard-add-outline'" />
        </button>
      </div>

      <ClientOnly>
        <Board :current-board-state="current.boardState" @position-clicked="handlePositionClicked" />
      </ClientOnly>
    </div>
  </div>
</template>
